/*
	GL_Antikad (0.22)
	29/01/2006

	!!!! THIS IS A TEST or IDEA USE IT AT YOUR RISK!!!!
	!!!! THIS IS A TEST or IDEA USE IT AT YOUR RISK!!!!
	!!!! THIS IS A TEST or IDEA USE IT AT YOUR RISK!!!!
	!!!! THIS IS A TEST or IDEA USE IT AT YOUR RISK!!!!
	!!!! THIS IS A TEST or IDEA USE IT AT YOUR RISK!!!!
	Simple script to check if the user is using the
	p2p network kad. Recently I downloaded the script:
	Highland.DC.Hub.Script.To.Search.Glftpd.User.Files-IND
	and I started to think how check users from kad (used with
	emule), but without use an ip database to deny access to
	them. This script works with pre_check command, simply
	check and block downloads, but leave to the user the
	chance to upload files and increase credits.

	X Install
	compile it with:
	gcc -o GLFTPD_PATH/bin/checker checker.c
 
	in glftpd.conf just add the line:
	pre_check       /bin/checker

	This util move the right user file in /ftp-data/users/backup
	and it need to write in 'users' dir, so (I know it's not secure),
	you have to use: chmod 0777 /ftp-data/users/
	I will tray to think a way to fix this problem.
	The util is wrote to be trasparent to the common users, so
	it will not print anything on stdout.
	
	X Notes
	- if you define DEBUG remove the pre_check setting
	use it if you wanna check some problems in users files.
	- you can undefine FAST, to use another way to check the user
	kad port (it sends the HELLO opcode with more data).
	- Glftpd should always print the ip user and not the hostname,
	if you have problems you can use the routine 'u_long resolv'
	and be sure to have the required lib in /lib (libresolv-X.X.X).

*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <string.h>
#include <errno.h>

#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>

/* You can change the path, port to check kad, and timeout */
#define BASE	"/ftp-data/users/" 
#define	PORT	4672
#define TIMEOUT 3


/* STOP SET VARS */
#define FAST
//#define DEBUG
#define HEADER	0xe4
#define HELLO	0x10
#define KADEMLIA_FIREWALLED_REQ	0x50
#define DONE 0x00

/* Other stuff  Please don't touch. */
#define VERSION "GL_AntiKad"
#define MAXLEN	1024
typedef unsigned char *int128;

FILE	*cfg, *out;
char	buf[MAXLEN], buf2[MAXLEN], wbuf[MAXLEN], host[255], user[255];
int sockfd, err;
struct	stat st;

int timeout(int sock);
u_long resolv(char *host);
static unsigned char *putpeernode(unsigned char **ppb, int ipd);
static unsigned char *putint128(unsigned char **ppb, int128 hash);
static unsigned char *putushort(unsigned char **ppb, unsigned short int u);
static unsigned char *putulong(unsigned char **ppb, unsigned long int u);
void getword(char *word, char *line, char stop);

check(char *ipz, u_short port) {
	struct sockaddr_in serv_addr;
	struct sockaddr_in local;
	unsigned char kadbuf[27];
	int ipf, status, on=1;

	/* sockfd = socket (PF_INET, SOCK_DGRAM, IPPROTO_UDP); */
	if((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) { 
	/* if (sockfd < 0) { */
#ifdef DEBUG
		perror ("Socket Init Failure");
#endif
		exit (-1);
	}

	if(setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, (void *)&on, sizeof(on)) < 0) {
#ifdef DEBUG
		perror ("Socket Init Failure");
#endif
		exit (-1);
	}
	bzero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = inet_addr(ipz);
	/* serv_addr.sin_port = htons(port); */
	serv_addr.sin_port = htons((unsigned short int)port);

	if (connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {
#ifdef DEBUG
		printf("WRN error connecting to %s port: %d\n",ipz,port);
#endif
		return -1;
	}
	ipf=inet_addr(ipz);
	unsigned char *pb = kadbuf;
	*pb++ = HEADER;

#ifdef FAST
	*pb++ = KADEMLIA_FIREWALLED_REQ;
	putushort(&pb, (unsigned short int)port);
#else
	*pb++ = HELLO;
	putpeernode(&pb, ipf);
#endif

	*pb++ = DONE;
#ifdef DEBUG
	printf("NFO sending %s...\n", kadbuf);
#endif
	status = sendto(sockfd, (char *)kadbuf, strlen(kadbuf),
		0, (struct sockaddr *)&serv_addr,
		(socklen_t)sizeof(serv_addr));
#ifdef DEBUG
	if(status) { perror("sendto"); }
#endif

	if(timeout(sockfd) < 0) {
#ifdef DEBUG
		fputs("Error: socket timeout, no reply received\n", stdout);
#endif
		return 1;
	}
	
	close(sockfd);
	return 0;
}

static unsigned char *putpeernode(unsigned char **ppb, int ipd) {
	putint128(ppb, "5c06d13ea9ea43414dde971cc3c2321c"); /* glftpd fake md5 hash */
	putulong(ppb, ipd);
	putushort(ppb, 4672);
	putushort(ppb, 4672);
	*(*ppb)++ = 1;
	return *ppb;
}

int timeout(int sock) {
    struct timeval tout;
    fd_set fd_read;
    int err;

    tout.tv_sec = TIMEOUT;
    tout.tv_usec = 0;
    FD_ZERO(&fd_read);
    FD_SET(sock, &fd_read);
    err = select(sock + 1, &fd_read, NULL, NULL, &tout);
    if(err<0) perror("Error"); 
    if(!err) return(-1);
    return(0);
}

/* u_long resolv(char *host) {
    struct hostent *hp;
    u_long host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
#ifdef DEBUG
            printf("\nError: Unable to resolv hostname (%s)\n", host);
#endif
            exit(1);
        } else host_ip = *(u_long *)hp->h_addr;
    }
    return(host_ip);
} */

static unsigned char *putint128(unsigned char **ppb, int128 hash) {
        int i, j;
        for(i=0; i<16; i+=4)
                for(j=3; j>=0; j--)
                        *(*ppb)++ = hash[i+j];
        return *ppb;
}

static unsigned char *putushort(unsigned char **ppb, unsigned short int u) {
        *(*ppb)++ = (unsigned char)u; u = u>>8;
        *(*ppb)++ = (unsigned char)u;
        return *ppb;
}

static unsigned char *putulong(unsigned char **ppb, unsigned long int u) {
        *(*ppb)++ = (unsigned char)u; u = u>>8;
        *(*ppb)++ = (unsigned char)u; u = u>>8;
        *(*ppb)++ = (unsigned char)u; u = u>>8;
        *(*ppb)++ = (unsigned char)u;
        return *ppb;
}

/* GetWord */
void
getword(char *word, char *line, char stop)
{
	int		x = 0,
			y;

	for (x = 0; ((line[x]) && (line[x] != stop)); x++)
	word[x] = line[x];

	word[x] = '\0';
	if (line[x])
		++x;
	y = 0;

	while ((line[y++] = line[x++]));
}

main (argc, argv)
        int     argc;
        char    *argv[];
{
	int sd=0, d1, d2, d3, d4, whut;
	char	qtn[255], qt[255];
	sprintf(host,"%s",getenv("HOST"));
	sprintf(user,"%s",getenv("USER"));
	if(buf == NULL) {
#ifdef DEBUG
		printf("WRN no HOST enviroment\n");
		exit(1);
#endif
	} else {
		getword(buf,host,'@');
#ifdef DEBUG
		printf("NFO user ip: %s\n", host);
#endif
		/* check(host,PORT,"WT"); */
		/* check("82.58.217.90",PORT); */
		whut=check(host,PORT);
#ifdef DEBUG
		printf("whut=%d\n",whut);
#endif
		sprintf(qt,"%s%s", BASE, user);
		sprintf(qtn,"%skad/%s", BASE, user);
		if(whut==0) {
#ifdef DEBUG
			printf("%s is using kad\n", user);
#endif
			if ((cfg = fopen(qt, "r"))!=NULL) {
				if ((out=fopen(qtn,"w"))!=NULL) {
					while (fgets(buf, MAXLEN, cfg) != NULL) {
						if(sd==0) {
							sprintf(buf2,buf);
							getword(wbuf,buf,' ');
							if(strcmp(wbuf,"LOGINS")==0) {
								sscanf(buf, "%d %d %d %d", &d1, &d2, &d3, &d4);
								fprintf(out,"LOGINS %d %d 0 %d\n", d1, d2, d4);
								sd=1;
							} else {
								fprintf(out,buf2);
							}
						} else if (sd==1) {
							fprintf(out,buf);
						}
					}
					fflush(out);
					fclose(out);
					fclose(cfg);
					sprintf(buf,"mv %s %s.bak", qt, qtn);
					system(buf);
					sprintf(buf,"mv %s %s", qtn, qt);
					//printf("SYS %s\n",buf);
					system(buf);
				} else {
#ifdef DEBUG
					printf("WRN unable to open %s user kad file\n", user);
#endif
				}
			} else {
#ifdef DEBUG
				printf("WRN unable to open %s user file\n", user);
#endif
			}
		} else if (whut==1) {
#ifdef DEBUG
			printf("%s is not using kad\n",user);
#endif
			sprintf(qtn,"%s.bak",qtn);
			if(sd=stat(qtn, &st)==0) {
#ifdef DEBUG
				printf("%s blocked (was using kad), fixing\n", user);
#endif
				sprintf(buf,"/bin/mv %s %s", qtn, qt);
				/* printf("SYS %s\n",buf); */
				system(buf);
			}
		}
	}
	exit(0);
}

